<template>
    <GridLayout rows="auto,*" verticalAlignment="top">
        <Label row="0" marginTop="30" text="coffre fort" class="title med" />
        <StackLayout>

            <StackLayout class="btn-img" padding="10"
                @tap="startAccelerometer"
                :visibility="accelerometerValues.x ? 'collapsed' : 'visible'">
                <Image marginTop="250"src="~/assets/btnLON.png" />
            </StackLayout>


            <StackLayout
                :visibility="accelerometerValues.x ? 'visible' : 'collapsed'">
                <Label marginLeft="100" marginTop="300"
                    :text="'X: ' + accelerometerValues.x" />
                <Label marginLeft="100"
                    :text="'Y: ' + accelerometerValues.y" />
                <Label marginLeft="100"
                    :text="'Z: ' + accelerometerValues.z" />
            </StackLayout>

        </StackLayout>
    </GridLayout>
</template>

<script>
    const accelerometer = require("nativescript-accelerometer");
    let accelerometerListening = false;

    import {
        Cards
    } from "../data/cards";
    const Detail = {
        props: ["name", "value", "meaning_up", "meaning_rev"],
        template: `
            <ModalStack class="modal-container">
                <GridLayout class="card modal" rows="auto,auto" verticalAlignment="middle">
                    <Button row="0" @tap="$modal.close" class="fa close" :text="'fa-times' | fonticon" horizontalAlignment="right" />
					<StackLayout row="1" ref="meaningContainer" class="list-item list-item-meaning">
						<Image col="0" :src="'~/assets/emoji/' + value + '.png' " class=" emoji_window" />
						<Label col="1" :text="name" class="card-title"
					            style="text-align: center;padding-bottom: 24;" />
					                <GridLayout columns="20,*" rows="*,*">
					                    <Image col="0" row="0" class="arrow"
					                            verticalAlignment="top" src="~/assets/arrow_up.png" style="margin-top: 5; margin-right: 10" />
					                        <Label col="1" row="0" verticalAlignment="top"
					                            :text="meaning_up" textWrap="true"
					                            style="margin-bottom:25; font-size: 16;" />
					                        <Image col="0" row="1" class="arrow2"
					                            verticalAlignment="top" src="~/assets/arrow_down.png" style="margin-top: 5; margin-right: 10" />
					                        <Label col="1" row="1" verticalAlignment="top"
					                            :text="meaning_rev" textWrap="true" style="font-size: 16" />
					                    </GridLayout>
					    </StackLayout>
                </GridLayout>
            </ModalStack>
	    `
    };
    export default {
        data() {
            return {
                accelerometerValues: {
                    x: null,
                    y: null,
                    z: null
                },

                cards: Cards,
                name: "",
                meaning_up: "",
                meaning_rev: "",
                emoji: "",
                value: "",
                allCards: [],
                detailPage: Detail
            };
        },
        methods: {
            startAccelerometer: function() {
                if (accelerometerListening) {
                    accelerometer.stopAccelerometerUpdates();
                }
                accelerometer.startAccelerometerUpdates(
                    data => {
                        accelerometerListening = true;
                        this.accelerometerValues = data;
                    }, {
                        sensorDelay: "ui"
                    }
                );
            },

            showDetailPageModally(item) {
                this.$showModal(Detail, {
                    props: {
                        name: item.name,
                        value: item.value,
                        meaning_up: item.meaning_up,
                        meaning_rev: item.meaning_rev
                    }
                });
            },
            getAllCards() {
                this.cards.forEach((card, index) => {
                    if (card.type == "major") {
                        this.allCards.push({
                            name: card.name,
                            emoji: card.emoji,
                            value: card.value,
                            meaning_up: card.meaning_up,
                            meaning_rev: card.meaning_rev,
                            visibility: "collapsed",
                            id: index
                        });
                    }
                });
            },
            toggleItem(item) {
                if (item.visibility == "collapsed") {
                    item.visibility = "visible";
                } else if (item.visibility == "visible") {
                    item.visibility = "collapsed";
                }
            }
        },
        created() {
            this.getAllCards();
        }
    };
</script>

<style scoped>
    .meaning-card {
        margin: 10;
        padding: 5;
    }

    .arrow {
        margin-right: 5;
    }

    .arrow2 {
        margin-right: 5;
    }
</style>